---
kind: "DaemonSet"
apiVersion: "extensions/v1beta1"
metadata:
  name: "{{ gluster_provisioner_name }}"
  namespace: {{ gluster_provisioner_namespace }}
  labels:
    glusterfs: "deployment"

  annotations:
    description: "GlusterFS Daemon Set"
    tags: "glusterfs"

spec:
  template:
    metadata:
      name: "{{ gluster_provisioner_prefix }}"
      namespace: {{ gluster_provisioner_namespace }}
      labels:
        glusterfs-node: "daemonset"

    spec:
      nodeSelector:
        storagenode: "gluster"

      serviceAccountName: "{{ gluster_provisioner_prefix }}"
      hostNetwork: true
      containers:
        - image: "gluster/gluster-centos:latest"
          imagePullPolicy: "Always"
          name: "glusterfs"
          volumeMounts:
            - name: "gluster-heketi"
              mountPath: "/var/lib/heketi"
            - name: "gluster-run"
              mountPath: "/run"
            - name: "gluster-lvm"
              mountPath: "/run/lvm"
            - name: "gluster-etc"
              mountPath: "/etc/glusterfs"
            - name: "gluster-logs"
              mountPath: "/var/log/glusterfs"
            - name: "gluster-config"
              mountPath: "/var/lib/glusterd"
            - name: "gluster-dev"
              mountPath: "/dev"
            - name: "gluster-cgroup"
              mountPath: "/sys/fs/cgroup"

          securityContext:
            capabilities: {}
            privileged: true

          readinessProbe:
            timeoutSeconds: 3
            initialDelaySeconds: 60
            exec:
              command:
                - "/bin/bash"
                - "-c"
                - "systemctl status glusterd.service"

          livenessProbe:
            timeoutSeconds: 3
            initialDelaySeconds: 60
            exec:
              command:
                - "/bin/bash"
                - "-c"
                - "systemctl status glusterd.service"

      volumes:
        - name: "gluster-heketi"
          hostPath:
            path: "/var/lib/heketi"
        - name: "gluster-run"

        - name: "gluster-lvm"
          hostPath:
            path: "/run/lvm"

        - name: "gluster-etc"
          hostPath:
            path: "/etc/glusterfs"

        - name: "gluster-logs"
          hostPath:
            path: "/var/log/glusterfs"

        - name: "gluster-config"
          hostPath:
            path: "/var/lib/glusterd"

        - name: "gluster-dev"
          hostPath:
            path: "/dev"

        - name: "gluster-cgroup"
          hostPath:
            path: "/sys/fs/cgroup"
